- Home
- API Enriched
- Managed Kubernetes
- config
- Replace Configuration Specification.
Replace Configuration Specification.
const url = 'https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/k8s_cluster_roles/example';const options = { method: 'PUT', headers: {Authorization: '<Authorization>', 'Content-Type': 'application/json'}, body: '{"metadata":{"annotations":{},"description":"example","disable":true,"labels":{},"name":"example","namespace":"example"},"spec":{"k8s_cluster_role_selector":{"expressions":["example"]},"policy_rule_list":{"policy_rule":[{"non_resource_url_list":{"urls":["example"],"verbs":["example"]},"resource_list":{"api_groups":["example"],"resource_instances":["example"],"resource_types":["example"],"verbs":["example"]}}]},"yaml":"example"}}'};
try { const response = await fetch(url, options); const data = await response.json(); console.log(data);} catch (error) { console.error(error);}curl --request PUT \ --url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/k8s_cluster_roles/example \ --header 'Authorization: <Authorization>' \ --header 'Content-Type: application/json' \ --data '{ "metadata": { "annotations": {}, "description": "example", "disable": true, "labels": {}, "name": "example", "namespace": "example" }, "spec": { "k8s_cluster_role_selector": { "expressions": [ "example" ] }, "policy_rule_list": { "policy_rule": [ { "non_resource_url_list": { "urls": [ "example" ], "verbs": [ "example" ] }, "resource_list": { "api_groups": [ "example" ], "resource_instances": [ "example" ], "resource_types": [ "example" ], "verbs": [ "example" ] } } ] }, "yaml": "example" } }'Replacing an k8s_cluster_role object will update the object by replacing the existing spec with the provided one. For read-then-write operations a resourceVersion mismatch will occur if the object was modified between the read and write.
Authorizations
Section titled “Authorizations”Parameters
Section titled “Parameters”Path Parameters
Section titled “Path Parameters”Namespace This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
Name The configuration object to be replaced will be looked up by name.
Request Bodyrequired
Section titled “Request Bodyrequired”This is the input message of the ‘Replace’ RPC.
object
object
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.
object
Human readable description for the object.
A value of true will administratively disable the object.
Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.
object
This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.
This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""
object
object
Expressions contains the Kubernetes style label expression for selections. Required: YES.
object
List of rules for role permissions
Required: YES.
Rule for role permission.
object
object
Allowed URL(s) that do not represent any K8s resource. URL can be suffix or regex. Required: YES.
Allowed list of verbs(operations) on resources. Use VerbAll for all operations Required: YES.
object
Allowed list of API group that contains resources, all resources of a given API group Required: YES.
Allowed list of resource instances within the resource types.
Allowed list of resource types within the API groups. Required: YES.
Allowed list of verbs(operations) on resources. Use * for all operations Required: YES.
Exclusive with [k8s_cluster_role_selector policy_rule_list] K8s YAML for ClusterRole.
Examplegenerated
{ "metadata": { "annotations": {}, "description": "example", "disable": true, "labels": {}, "name": "example", "namespace": "example" }, "spec": { "k8s_cluster_role_selector": { "expressions": [ "example" ] }, "policy_rule_list": { "policy_rule": [ { "non_resource_url_list": { "urls": [ "example" ], "verbs": [ "example" ] }, "resource_list": { "api_groups": [ "example" ], "resource_instances": [ "example" ], "resource_types": [ "example" ], "verbs": [ "example" ] } } ] }, "yaml": "example" }}Responses
Section titled “Responses”A successful response.
object
Examplegenerated
{}Returned when operation is not authorized.
Examplegenerated
exampleReturned when there is no permission to access resource.
Examplegenerated
exampleReturned when resource is not found.
Examplegenerated
exampleReturned when operation on resource is conflicting with current value.
Examplegenerated
exampleReturned when operation has been rejected as it is happening too frequently.
Examplegenerated
exampleReturned when server encountered an error in processing API.
Examplegenerated
exampleReturned when service is unavailable temporarily.
Examplegenerated
exampleReturned when server timed out processing request.
Examplegenerated
example